function obj = algoobj_demo1()

% Demonstration algorithm 1
obj = SCDDSdemo_algo('algo_demo1');

%% Timing of the algorithm
obj=obj.settiming(-1,1e-3,1.0);

%% Fixed parameters init functions 
obj=obj.addfpinitfcn('algo_demo1_loadfp','algo_demo1_fp');

%% Tunable parameters structure name
obj=obj.addtunparamstruct('algo_demo1_tp', @()algo_demo1_loadtp(), false);

%% Tunable parameters
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.enable.value'        ,'enable'          ,'mdshelp','a bool param')); 
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.gain.value'          ,'gain'            ,'mdshelp','a tunable gain'));
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.refmodel.gain.value' ,'refmodel.gain'   ,'mdshelp','a tunable gain'));
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.rowvect.value'       ,'rowvect'         ,'mdshelp','a row vector'));
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.colvect.value'       ,'colvect'         ,'mdshelp','a column vector'));
obj=obj.addparameter(SCDDSdemo_mdsparnumeric('demo1.params.matrix.value'        ,'matrix'          ,'mdshelp','a matrix'));

%% Wavegens
[mdsserver,mdstree] = SCDDSdemo.get_mdsserver();
obj=obj.addwavegenbasetruct('algo_demo1_inbus1');
obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'demo1.inputs.signal1','signal1'        ,'srcsrv',mdsserver,'srctree',mdstree));
obj=obj.addwavegen(SCDclass_mdswgsigsingle( 'demo1.inputs.signal2','signal2'        ,'srcsrv',mdsserver,'srctree',mdstree));


%% Buses
obj = obj.addbus('algo_demo1_inBus', 'algo_demo1_inBus_def' );
obj = obj.addbus('algo_demo1_outBus', 'algo_demo1_outBus_def' );

 % function handle that returns cell arays of buses and busnames to be registered
obj = obj.addbus('',@() algo_demo1_signal_buses());

%% Tasks

%% Print (optional)
obj.printinfo;

end

