classdef SCDDSdemo < SCDDSclass
  
  methods(Static)
    function setup_paths
      rootpath = fileparts(fileparts(mfilename('fullpath')));
      run(fullfile(rootpath,'scdds_demo_paths'));
    end
    
    function where = getsite()
     [~,hostname] = system('hostname -A');
      hostname = lower(deblank(hostname));
      if contains(hostname,'epfl.ch')
        where = 'EPFL';
      elseif contains(hostname,'mit.edu')
        where ='PSFC';
      else
        error('don''t know how to treat hostname %s',hostname);
      end
    end
    
    function [mdsserver,mdstree] = get_mdsserver()
        where = SCDDSdemo.getsite();
      % Set defaults for our case
      if contains(where,'EPFL')
        mdsserver = 'scd.epfl.ch';
      elseif contains(where,'PSFC')
        mdsserver='alcdaq6.psfc.mit.edu';
      else
        error('don''t know how to treat location %s',where);
      end
      mdstree = 'scdds';
    end
  end
end